"""
    NVIDIA NeMo LLM service

    # Introduction NeMo LLM Service offers state-of-the-art LLMs that were pre-trained on internet-scale text corpora. </br> With NeMo LLM Service API users can invoke the services from within their application code. </br> These models can be flexibly adapted to solve almost any language processing task for your use cases. You can conveniently and quickly try them out, and via an API that you can easily integrate into your applications. </br> Further, the NeMo LLM Service also offers customization capabilities, where the models can be effectively adapted to new tasks, using your own uploaded data.  ### Models:  The NeMo LLM Service is powered by a set of large language models of varying sizes and capabilities. Generally, larger models extend the capabilities of what smaller models can do with text. - Large models, such as the 530B, are excellent for complex tasks that require a deep understanding of human languages and all their nuances, such as text summarization, creative writing, or chatbot applications. - Medium models, such as the 20B, are faster than the large models. They are sufficiently good for many tasks such as writing emails and factual question answering. - Small models, such as the 5B, are the fastest and can perform many simple language tasks, such as text classification and spelling correction. </br></br> Each model can be used for \"Completion\" or text generation with One/Few-Shot Learning as well as \"Customization\" with your custom dataset. </br></br> ### The NeMo LLM Service API  comprises the following features:   - Text Completion. With one of the available and pre-trained model the LLM service responds to an input prompt by generating an extension to the provided intut text, that is, a completion. This technique can be used for solving multiple NLP tasks using Zero/Few-shot learning techniques.   - Model Customization. With which you can finetune an existing model on your own custom data in the form of prompt+completion pairs. This enhances the model’s ability to adapt to your use cases by ingesting hundreds to thousands of domain-specific examples.   Please **[submit NVBug](https://nvbugswb.nvidia.com/NvBugs5/SWBug.aspx?bugid=3682160&cmtNo=)** (by cloning and submitting) if discovered any issues.   # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from nemollm.exceptions import ApiAttributeError
from nemollm.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    OpenApiModel,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
)


class CompletionRequestBody(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
        ('beam_width',): {'None': None, '1': 1, '2': 2, '3': 3, '4': 4, '8': 8, '16': 16, '32': 32,},
    }

    validations = {
        ('prompt',): {'max_length': 4096, 'min_length': 1,},
        ('tokens_to_generate',): {'inclusive_maximum': 2048, 'inclusive_minimum': 1,},
        ('temperature',): {'inclusive_maximum': 1.0, 'inclusive_minimum': 0,},
        ('top_p',): {'inclusive_maximum': 1.0, 'inclusive_minimum': 0,},
        ('top_k',): {'inclusive_maximum': 64, 'inclusive_minimum': 0,},
        ('stop',): {'max_items': 10, 'min_items': 0,},
        ('repetition_penalty',): {'inclusive_maximum': 2.0, 'inclusive_minimum': 1.0,},
        ('beam_search_diversity_rate',): {'inclusive_maximum': 1.0, 'inclusive_minimum': 0,},
        ('length_penalty',): {'inclusive_maximum': 1.0, 'inclusive_minimum': 0,},
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        return (
            bool,
            date,
            datetime,
            dict,
            float,
            int,
            list,
            str,
            none_type,
        )  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        return {
            'prompt': (str,),  # noqa: E501
            'tokens_to_generate': (int, none_type,),  # noqa: E501
            'logprobs': (bool, none_type,),  # noqa: E501
            'temperature': (float, none_type,),  # noqa: E501
            'top_p': (float, none_type,),  # noqa: E501
            'top_k': (int, none_type,),  # noqa: E501
            'stop': ([str], none_type,),  # noqa: E501
            'random_seed': (int, none_type,),  # noqa: E501
            'repetition_penalty': (float, none_type,),  # noqa: E501
            'beam_search_diversity_rate': (float, none_type,),  # noqa: E501
            'beam_width': (int, none_type,),  # noqa: E501
            'length_penalty': (float, none_type,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None

    attribute_map = {
        'prompt': 'prompt',  # noqa: E501
        'tokens_to_generate': 'tokens_to_generate',  # noqa: E501
        'logprobs': 'logprobs',  # noqa: E501
        'temperature': 'temperature',  # noqa: E501
        'top_p': 'top_p',  # noqa: E501
        'top_k': 'top_k',  # noqa: E501
        'stop': 'stop',  # noqa: E501
        'random_seed': 'random_seed',  # noqa: E501
        'repetition_penalty': 'repetition_penalty',  # noqa: E501
        'beam_search_diversity_rate': 'beam_search_diversity_rate',  # noqa: E501
        'beam_width': 'beam_width',  # noqa: E501
        'length_penalty': 'length_penalty',  # noqa: E501
    }

    read_only_vars = {}

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, *args, **kwargs):  # noqa: E501
        """CompletionRequestBody - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            prompt (str): Prompt text. Input text that will be followed by generation. [optional]  # noqa: E501
            tokens_to_generate (int, none_type): Max number of tokens to generate. [optional] if omitted the server will use the default value of 24  # noqa: E501
            logprobs (bool, none_type): Include logprobs in the response. [optional] if omitted the server will use the default value of False  # noqa: E501
            temperature (float, none_type): Controls the randomness of selecting the next token during text generation. Lower values reduce randomness . [optional] if omitted the server will use the default value of 1.0  # noqa: E501
            top_p (float, none_type): Sampling from the minimum number of top tokens whose probabilities sum to or exceed top_p . [optional] if omitted the server will use the default value of 1.0  # noqa: E501
            top_k (int, none_type): How many of the top tokens to sample from . [optional] if omitted the server will use the default value of 1  # noqa: E501
            stop ([str], none_type): Sequences when completion generation will stop . [optional] if omitted the server will use the default value of []  # noqa: E501
            random_seed (int, none_type): The model generates random results. Changing the random seed alone will produce a different response with similar characteristics. It is possible to reproduce results by fixing the random seed (assuming all other hyperparameters are also fixed) . [optional] if omitted the server will use the default value of 0  # noqa: E501
            repetition_penalty (float, none_type): How much to penalize tokens based on how frequently they occur in the text. A value of 1 means no penalty, while values larger than 1 discourage repeated tokens . [optional] if omitted the server will use the default value of 1.0  # noqa: E501
            beam_search_diversity_rate (float, none_type): Only applies to beam search, i.e. when the beam width is >1. A higher value encourages beam search to return a more diverse set of candidates . [optional] if omitted the server will use the default value of 1.0  # noqa: E501
            beam_width (int, none_type): The number of concurrent candidates to keep track of during beam search . [optional] if omitted the server will use the default value of 1  # noqa: E501
            length_penalty (float, none_type): Only applies to beam search, i.e. when the beam width is >1. Larger values penalize long candidates more heavily, thus preferring shorter candidates . [optional] if omitted the server will use the default value of 1.0  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', True)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments."
                        % (args, self.__class__.__name__,),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if (
                var_name not in self.attribute_map
                and self._configuration is not None
                and self._configuration.discard_unknown_keys
                and self.additional_properties_type is None
            ):
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set(
        [
            '_data_store',
            '_check_type',
            '_spec_property_naming',
            '_path_to_item',
            '_configuration',
            '_visited_composed_classes',
        ]
    )

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """CompletionRequestBody - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            prompt (str): Prompt text. Input text that will be followed by generation. [optional]  # noqa: E501
            tokens_to_generate (int, none_type): Max number of tokens to generate. [optional] if omitted the server will use the default value of 24  # noqa: E501
            logprobs (bool, none_type): Include logprobs in the response. [optional] if omitted the server will use the default value of False  # noqa: E501
            temperature (float, none_type): Controls the randomness of selecting the next token during text generation. Lower values reduce randomness . [optional] if omitted the server will use the default value of 1.0  # noqa: E501
            top_p (float, none_type): Sampling from the minimum number of top tokens whose probabilities sum to or exceed top_p . [optional] if omitted the server will use the default value of 1.0  # noqa: E501
            top_k (int, none_type): How many of the top tokens to sample from . [optional] if omitted the server will use the default value of 1  # noqa: E501
            stop ([str], none_type): Sequences when completion generation will stop . [optional] if omitted the server will use the default value of []  # noqa: E501
            random_seed (int, none_type): The model generates random results. Changing the random seed alone will produce a different response with similar characteristics. It is possible to reproduce results by fixing the random seed (assuming all other hyperparameters are also fixed) . [optional] if omitted the server will use the default value of 0  # noqa: E501
            repetition_penalty (float, none_type): How much to penalize tokens based on how frequently they occur in the text. A value of 1 means no penalty, while values larger than 1 discourage repeated tokens . [optional] if omitted the server will use the default value of 1.0  # noqa: E501
            beam_search_diversity_rate (float, none_type): Only applies to beam search, i.e. when the beam width is >1. A higher value encourages beam search to return a more diverse set of candidates . [optional] if omitted the server will use the default value of 1.0  # noqa: E501
            beam_width (int, none_type): The number of concurrent candidates to keep track of during beam search . [optional] if omitted the server will use the default value of 1  # noqa: E501
            length_penalty (float, none_type): Only applies to beam search, i.e. when the beam width is >1. Larger values penalize long candidates more heavily, thus preferring shorter candidates . [optional] if omitted the server will use the default value of 1.0  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments."
                        % (args, self.__class__.__name__,),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if (
                var_name not in self.attribute_map
                and self._configuration is not None
                and self._configuration.discard_unknown_keys
                and self.additional_properties_type is None
            ):
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(
                    f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                    f"class with read only attributes."
                )
